#include <iostream>
    #include <cstdio>
    #include <cstring>
    #include <algorithm>
    #include <string>

    using namespace std;

    #define INF 1<<31-1
    int tri[12]= {0,1,3,9,27,81,243,729,2187,6561,19683,59049};//1220
    int dp[59050][12];
    int dig[59050][12];//i059049jdig[i][j]ij
    int edge[12][12];

    int main(){
        int n, m;
        int i, j;
        int ans;
        for(i = 0; i < 59050; i ++){
            int tmp = i;
            for(j = 1; j <= 10; j ++){
                dig[i][j] = tmp % 3;
                tmp = tmp/3;
            }
        }
        while(cin >> n >> m){
            ans = INF;
            for(i = 1; i <= n; i ++){
                for(j = 1; j <= n; j ++)
                    edge[i][j] = INF;
            }
            for(i = 0; i < tri[n+1]; i ++){
                for(j = 1; j <= n; j ++){
                    dp[i][j] = INF;
                }
            }
            for(i = 1; i <= 10; i ++){
                dp[tri[i]][i] = 0;//ii0
            }
            for(i = 1; i <= m; i ++){
                int a, b, c;
                scanf("%d %d %d", &a, &b, &c);
                if(edge[a][b] > c){
                    edge[a][b] = c;
                    edge[b][a] = c;
                }
            }
            for(int s = 0; s < tri[n+1]; s ++){
                int vis_all = 1;//
                for(i = 1; i <= n; i ++){
                    if(dig[s][i] == 0)
                        vis_all =0;//SiS
                    if(dp[s][i] == INF)
                        continue;
                    for(j = 1; j <= n; j ++){
                        if(i == j)
                            continue;
                        if(edge[i][j] == INF || dig[s][j] == 2)//ijijj
                            continue;
                        int ns = s + tri[j];
                        dp[ns][j] = min(dp[ns][j], dp[s][i] + edge[i][j]);
                    }
                }
                if(vis_all)
                for(j = 1; j <= n; j ++){
                    ans = min(ans, dp[s][j]);//S
                }
            }
            if(ans == INF)
                cout << "-1" << endl;
            else
                cout << ans << endl;
        }
        return 0;
    }